/* $Id: CVFreqInstance.cc,v 1.2 2003/08/06 10:02:42 andete Exp $

lemux - LADSPA instrument plugins based on openMSX devices

(c) 2003 Joost Yervante Damad <joost@lumatec.be>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "CVFreqInstance.hh"

#include <math.h>

// based on formula from alsamodular:
static float _log2 = 0.69314718056;
float CVtoFREQ(float cv)
{
        float freq_tune = 5.0313842 + cv;
        return 4.0313842*exp(_log2 * freq_tune);
}


#include <cassert>
#include <cstring>
#include <iostream>

CVFreqInstance::CVFreqInstance(unsigned long sampleRate)
:sampleRate(sampleRate)
{
}

CVFreqInstance::~CVFreqInstance()
{
}

void CVFreqInstance::connect_port(unsigned long port, LADSPA_Data* dataLocation)
{
	switch (port)
	{
		case 0:
			port_cv = dataLocation;
			break;
		case 1:
			port_freq = dataLocation;
			break;
		default:
			assert(false);
			break;
	}
}

void CVFreqInstance::activate()
{
}

void CVFreqInstance::run(unsigned long SampleCount)
{
	for (unsigned long i=0; i < SampleCount; i++)
	{
		port_freq[i] = CVtoFREQ(port_cv[i]);
	}
}

